#include <stdlib.h>
#include <cstdio>
#include <numeric>
#include <iostream>
#include <vector>
#include <set>
#include <cstring>
#include <string>
#include <map>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <bitset>
#include <queue>
#include <sstream>
#include <deque>

using namespace std;

#define mp make_pair
#define pb push_back
#define rep(i,n) for(int i = 0; i < (n); i++)
#define re return
#define fi first
#define se second
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define sqr(x) ((x) * (x))
#define sqrt(x) sqrt(abs(x))
#define y0 y3487465
#define y1 y8687969
#define fill(x,y) memset(x,y,sizeof(x))
#define prev PREV
                         
typedef vector<int> vi;
typedef long long ll;
typedef long double ld;
typedef double D;
typedef pair<int, int> ii;
typedef vector<ii> vii;
typedef vector<string> vs;
typedef vector<vi> vvi;

template<class T> T abs(T x) { re x > 0 ? x : -x; }

const int E = 5;
const int N = 1 << 16;
const int INF = 1e9;

int n;
int m;

string s;
string t;

int g[E][E];
int a[E + 1][E + 1];
int v[E + 1];
int u[E + 1];
int p[E + 1];
int way[E + 1];
int minv[E + 1];
int used[E + 1];
int q[E + 1];
int use[E + 1];
int cnt[N][E][E];

int V[E][2 * N];
int W[E][2 * N];
int U[2 * N];

int len;

const int mod = 7340033;
const int root = 5;
const int root_1 = 4404020;
const int root_pw = 1 << 20;

int power (int a, int b) {
	int c = 1;
	while (b) {
		if (b & 1) c = ((ll)c * a) % mod;
		b /= 2;
		a = ((ll)a * a) % mod;
	}
	re c;
}

void fft (int *a, bool invert, int n) {
	for (int i = 1, j = 0; i < n; i++) {
		int bit = n >> 1;
		for (; j >= bit; bit >>= 1) j -= bit;
		j += bit;
		if (i < j) swap (a[i], a[j]);
	}
	for (int len = 2; len <= n; len <<= 1) {
		int wlen = invert ? root_1 : root;
		for (int i = len; i < root_pw; i <<= 1)
			wlen = ((ll)wlen * wlen) % mod;
		for (int i = 0; i < n; i += len) {
			int w = 1;
			for (int j = 0; j < len / 2; j++) {
				int u = a[i + j];
				int v = ((ll)a[i + j + len / 2] * w) % mod;
				a[i + j] = u + v < mod ? u + v : u + v - mod;
				a[i + j + len / 2] = u - v >= 0 ? u - v : u - v + mod;
				w = ((ll)w * wlen) % mod;
			}
		}
	}
	if (invert) {
		int nrev = power (n, mod - 2);
		for (int i = 0; i < n; i++)
			a[i] = (ll)a[i] * nrev % mod;
	}
}

int calc () {
	for (int i = 0; i < E; i++)
		for (int j = 0; j < E; j++)
			a[i + 1][j + 1] = g[i][j];
	memset (u, 0, sizeof (u));
	memset (v, 0, sizeof (v));
	memset (p, 0, sizeof (p));
	memset (way, 0, sizeof (way));
	for (int i = 1; i <= E; i++) {
		p[0] = i;
		int j0 = 0;
		for (int j = 0; j < E + 1; j++) {
			minv[j] = INF;
			used[j] = 0;
		}	
		do {
			used[j0] = true;
			int i0 = p[j0],  delta = INF,  j1;
			for (int j=1; j<=E; ++j)
				if (!used[j]) {
					int cur = a[i0][j]-u[i0]-v[j];
					if (cur < minv[j])
						minv[j] = cur,  way[j] = j0;
					if (minv[j] < delta)
						delta = minv[j],  j1 = j;
				}
			for (int j=0; j<=E; ++j)
				if (used[j])
					u[p[j]] += delta,  v[j] -= delta;
				else
					minv[j] -= delta;
			j0 = j1;
		} while (p[j0] != 0);
		do {
			int j1 = way[j0];
			p[j0] = p[j1];
			j0 = j1;
		} while (j0);
	}
	re -v[0];
}

int main () {
	cin >> s >> t;
	n = sz (s);
	len = 1;
	while (len < n) len *= 2;
	len *= 2;
	for (int i = 0; i < E; i++) {
		for (int k = 0; k < n; k++) {
			V[i][k] = int (s[k] - 'A' == i);
			W[i][n - k] = int (t[k] - 'a' == i);
		}
		fft (V[i], false, len);
		fft (W[i], false, len);
	}
//	cerr << clock () << endl;
	for (int i = 0; i < E; i++)
		for (int j = 0; j < E; j++) {
			for (int k = 0; k < len; k++)
				U[k] = ((ll)V[i][k] * W[j][k]) % mod;
			fft (U, true, len);
			for (int k = 0; k < len; k++)
				cnt[k % n][i][j] += U[k];
		}
//	cerr << clock () << endl;
	int ans = 0;
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < E; i++)
			for (int j = 0; j < E; j++)
				g[i][j] = n - cnt[k][i][j];
		/*
		for (int i = 0; i < E; i++) {
			for (int j = 0; j < E; j++)
				printf ("%d ", cnt[k][i][j]);
			printf ("\n");
		}
		printf ("%d\n", E * n - calc ());
		*/
		ans = max (ans, E * n - calc ());
	}
	printf("%d\n", n - ans);
//	cerr << clock () << endl;
	return 0;
}