#include <cstdio>
#include <numeric>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <string>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <sstream>
#include <cassert>
#include <functional>
#include <numeric>

using namespace std;

#ifdef __WIN32__
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

#ifdef __WIN32__
    #define ULLD "%I64u"
#else
    #define ULLD "%llu"
#endif

#define mp make_pair
#define pb push_back
#define rep(i,n) for(int i = 0; i < (n); i++)
#define re return
#define fi first
#define se second
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define sqrt(x) sqrt(abs(x))
#define y0 y3487465
#define y1 y8687969
#define j0 j5743892
#define j1 j542893
                         
typedef vector<int> vi;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef double D;
typedef pair<int, int> ii;
typedef vector<ii> vii;
typedef vector<string> vs;
typedef vector<vi> vvi;

template<class T> T abs(T x) { re x > 0 ? x : -x; }
template<class T> T gcd(T a, T b) { re a ? gcd (b % a, a) : b; }
template<class T> T sqr(T a) { re a * a; }

#define popcount(x) __builtin_popcountll(x)

#define filename ""

const ll inf = 2e18;
const int N = 100000;

int n;
int m;

ll f[N];
vector<pair<ll, int> > v;

struct node {
	pair<ll, int> val;
	int pr;
	ll sum, now, top, add;
	node *left, *right;
	node () { };
	node (pair<ll, int> _val, int _pr) {
		val = _val;
		pr = _pr;
		left = right = NULL;
	}
};

typedef node * pnode;

bool ls (pair<ll, int> a, pair<ll, int> b) {
	re a.fi > b.fi || (a.fi == b.fi && a.se < b.se);
}

void push (pnode cur) {
	if (!cur) re;
	cur->now += cur->add;
	cur->top += cur->add;
	if (cur->left) cur->left->add += cur->add;
	if (cur->right) cur->right->add += cur->add;
	cur->add = 0;
	re;
}

ll gettop (pnode cur) {
	if (!cur) re -inf;
	re cur->top + cur->add;
}

ll getsum (pnode cur) {
	if (!cur) re 0;
	re cur->sum;
}

void upd (pnode cur) {
	if (!cur) re;
	push (cur);
	cur->top = max (cur->now, max (gettop (cur->left), gettop (cur->right)));
	cur->sum = cur->val.fi + getsum (cur->left) + getsum (cur->right);
	re;
}

void split (pnode cur, pair<ll, int> val, pnode &l, pnode &r) {
	push (cur);
	if (!cur) l = r = NULL; else
	if (ls (val, cur->val)) {
		split (cur->left, val, l, cur->left);
		r = cur;
	} else {
		split (cur->right, val, cur->right, r);	
		l = cur;
	}
	upd (cur);
	re;
}

void insert (pnode &cur, pair<ll, int> val, int pr, ll now) {
	push (cur);
	if (!cur) {
		pnode tmp = new node (val, pr);
		tmp->sum = val.fi;
		tmp->now = now;
		tmp->top = now;
		tmp->add = 0;
		cur = tmp;
	} else
	if (cur->pr > pr) {
		pnode tmp = new node (val, pr);
		tmp->sum = val.fi;
		tmp->now = now;
		tmp->top = now;
		tmp->add = 0;
		split (cur, val, tmp->left, tmp->right);
		cur = tmp;
	} else
	if (ls (val, cur->val))
		insert (cur->left, val, pr, now);
	else
		insert (cur->right, val, pr, now);	
	upd (cur);
	re;
}	

void merge (pnode &cur, pnode l, pnode r) {
	if (!l)
		cur = r;
	else
	if (!r)	
		cur = l;
	else
	if (l->pr > r->pr) {
		push (l);
		merge (l->right, l->right, r);
		cur = l;
	} else {
		push (r);
		merge (r->left, l, r->left);
		cur = r;
	}
	upd (cur);
	re;
}

void erase (pnode &cur, pair<ll, int> val) {
	push (cur);
	if (!cur) re;
	if (cur->val == val) {
		merge (cur, cur->left, cur->right);
	}
	else
	if (ls (val, cur->val))
		erase (cur->left, val);
	else
		erase (cur->right, val);	
	upd (cur);
	re;
}

int get (pnode cur, int& num) {
	push (cur);
	if (cur->top < 0) re -1;
	int tmp = get (cur->left, num);
	if (tmp != -1) re tmp;
	if (cur->now >= 0) {
		num--;
		if (!num) re cur->val.se;
	}
	re get (cur->right, num);
}

int calc (pnode cur) {
	push (cur);
	if (gettop (cur) < 0) re 0;
	re calc (cur->left) + calc (cur->right) + int (cur->now >= 0);
}

int myrand () {
	re (rand () << 16) + rand ();
}

int main () {
	scanf ("%d", &n);
	pnode root = NULL;
	for (int i = 0; i < n; i++) {
		scanf (LLD, &f[i]);
		v.pb (mp (f[i], i));
	}
	sort (all (v), ls);
	ll sum = 0;
	for (int i = n - 1; i >= 0; i--) {
		insert (root, v[i], myrand (), v[i].fi - sum);
		sum += v[i].fi;
	}
	cerr << clock () << endl;
	scanf ("%d", &m);
	printf ("%d\n", calc (root));
	int om = m;
	for (int i = 0; i < m; i++) {
		int a;
		ll b;
		scanf ("%d"LLD, &a, &b); a--;
		erase (root, mp (f[a], a));
		pnode left, right;
		split (root, mp (f[a], a), left, right);
		if (left) left->add += f[a];
		merge (root, left, right);
		f[a] = b;
		split (root, mp (f[a], a), left, right);
		if (left) left->add -= f[a];
		ll cur = getsum (right);
		merge (root, left, right);
		insert (root, mp (f[a], a), myrand (), f[a] - cur);
		printf ("%d\n", calc (root));
//		if (i % 1000 == 0) cerr << i << " " << m << endl;
	}
	cerr << clock () << endl;
    return 0;
}